<?
/*------------------------------------------

[Depends]

[Document]
lib_wb.phpƕps

------------------------------------------*/

//PHP5ȏŎs
if(version_compare(phpversion(), "5.0.0", "<")) return 0;

define('GMEM_FIXED',          0x0000);
define('GMEM_MOVEABLE',       0x0002);
define('GMEM_NOCOMPACT',      0x0010);
define('GMEM_NODISCARD',      0x0020);
define('GMEM_ZEROINIT',       0x0040);
define('GMEM_MODIFY',         0x0080);
define('GMEM_DISCARDABLE',    0x0100);
define('GMEM_NOT_BANKED',     0x1000);
define('GMEM_SHARE',          0x2000);
define('GMEM_DDESHARE',       0x2000);
define('GMEM_NOTIFY',         0x4000);
define('GMEM_LOWER',          GMEM_NOT_BANKED);
define('GMEM_DISCARDED',      0x4000);
define('GMEM_LOCKCOUNT',      0x00ff);
define('GMEM_INVALID_HANDLE', 0x8000);

define('GHND',                GMEM_MOVEABLE | GMEM_ZEROINIT);
define('GPTR',                GMEM_FIXED | GMEM_ZEROINIT);

function Win32API_GlobalAlloc($uFlags, $dwBytes) {
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GlobalAlloc", wb_load_library("Kernel32"));
	
	settype($uFlags, "integer");
	settype($dwBytes, "integer");
	
	$ret = wb_call_function($funcaddr, array($uFlags, $dwBytes));
	return $ret;
}
function Win32API_GlobalFree($hMem) {
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GlobalFree", wb_load_library("Kernel32"));
	
	settype($hMem, "integer");
	
	$ret = wb_call_function($funcaddr, array($hMem));
	return $ret;
}
function Win32API_GlobalDiscard($hMem) {
	return Win32API_GlobalReAlloc($hMem, 0, GMEM_MOVEABLE);
}
function Win32API_GlobalHandle($lpVoid) {
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GlobalHandle", wb_load_library("Kernel32"));
	
	settype($lpVoid, "integer");
	
	$ret = wb_call_function($funcaddr, array($lpVoid));
	return $ret;
}
function Win32API_GlobalLock($hMem) {
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GlobalLock", wb_load_library("Kernel32"));
	
	settype($hMem, "integer");
	
	$ret = wb_call_function($funcaddr, array($hMem));
	return $ret;
}
function Win32API_GlobalReAlloc($hMem, $dwBytes, $uFlags) {
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GlobalReAlloc", wb_load_library("Kernel32"));
	
	settype($hMem, "integer");
	settype($dwBytes, "integer");
	settype($uFlags, "integer");
	
	$ret = wb_call_function($funcaddr, array($hMem, $dwBytes, $uFlags));
	return $ret;
}
function Win32API_GlobalSize($hMem) {
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GlobalSize", wb_load_library("Kernel32"));
	
	settype($hMem, "integer");
	
	$ret = wb_call_function($funcaddr, array($hMem));
	return $ret;
}
function Win32API_GlobalUnlock($hMem) {
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GlobalUnlock", wb_load_library("Kernel32"));
	
	settype($hMem, "integer");
	
	$ret = wb_call_function($funcaddr, array($hMem));
	return $ret;
}
