<?

//PHP5ȏŎs
if(version_compare(phpversion(), "5.0.0", "<")) return 0;

if(!function_exists('get_class_members')) {
	//get_class_methodsget_class_varš̗ʂԂ
	function get_class_members($class, $type)
	{
		$class_ref = new ReflectionClass($class);
		if(! $class_ref instanceof ReflectionClass) return false;
		
		$methods = array();
		$properties = array();
		switch($type)
		{
		case "method":
			$methods = $class_ref->getMethods();
			break;
		case "property":
			$properties = $class_ref->getProperties();
			break;
		default:
			$methods = $class_ref->getMethods();
			$properties = $class_ref->getProperties();
			break;
		}
		
		if(! is_array($methods)) return $arr1;
		if(! is_array($properties)) return $arr2;
		
		$arr1 = array();
		$arr2 = array();
		
		foreach($methods as $method)
		{
			$arr1[] = $method->getName();
		}
		foreach($properties as $property)
		{
			$arr2[] = $property->getName();
		}
		
		return array_merge($arr1, $arr2);
	}

	//$casetruew肷ƁA啶ʂĔr
	function is_member($obj, $name, $case = true, &$cased_name = NULL, $type = NULL)
	{
		$class = "";
		
		if(is_object($obj))
			$class = get_class($obj);
		else if(is_string($obj))
			$class = $obj;
		else
		{
			trigger_error("parameter 1 must be object or string.", E_USER_WARNING);
			return false;
		}
		if(! is_string($name))
		{
			trigger_error("parameter 2 must be string.", E_USER_WARNING);
			return false;
		}
		
		$names = get_class_members($class, $type);
		if(! is_array($names)) return false;
		
		if(!$case)
		{
			$name = strtolower($name);
			$names = explode("::", strtolower(join("::", $names)));
		}
		
		if(! in_array($name, $names))
			return false;
		
		$index = array_search($name, $names);
		$names = get_class_members($class, $type);
		$cased_name = $names[$index];
		
		return true;
	}
	function is_public_member($obj, $name, $case = true, &$cased_name = NULL, $type = NULL)
	{
		$class = "";
		
		if(is_object($obj))
			$class = get_class($obj);
		else if(is_string($obj))
			$class = $obj;
		else
		{
			trigger_error("parameter 1 must be object or string.", E_USER_WARNING);
			return false;
		}
		if(! is_string($name))
		{
			trigger_error("parameter 2 must be string.", E_USER_WARNING);
			return false;
		}
		
		if(! is_member($class, $name, $case, $name, $type))
			return false;
		$cased_name = $name;
		
		$class_ref = new ReflectionClass($class);
		if(! $class_ref instanceof ReflectionClass) return false;
		
		switch($type)
		{
		case "method":
			$name_ref = $class_ref->getMethod($name);
			break;
		case "property":
			$name_ref = $class_ref->getProperty($name);
			break;
		default:
			if(is_method($class, $name))
				$name_ref = $class_ref->getMethod($name);
			else
				$name_ref = $class_ref->getProperty($name);
			break;
		}
		if((! $name_ref instanceof ReflectionMethod) && (! $name_ref instanceof ReflectionProperty)) return false;
		
		if(! $name_ref->isPublic())
			return false;
		
		return true;
	}
	function get_cased_member_name($obj, $name, $type)
	{
		$ret = "";
		if(! is_member($obj, $name, false, $ret, $type)) return false;
		return $ret;
	}
	function get_cased_method_name($obj, $name)
	{
		return get_cased_member_name($obj, $name, "method");
	}
	function get_cased_property_name($obj, $name)
	{
		return get_cased_member_name($obj, $name, "property");
	}
	function is_method($obj, $name, $case = true, &$cased_name = NULL)
	{
		return is_member($obj, $name, $case, $cased_name, "method");
	}
	function is_public_method($obj, $name, $case = true)
	{
		return is_public_member($obj, $name, $case, $cased_name, "method");
	}
	function is_property($obj, $name, $case = true, &$cased_name = NULL)
	{
		return is_member($obj, $name, $case, $cased_name, "is_property");
	}
	function is_public_is_property($obj, $name, $case = true)
	{
		return is_public_member($obj, $name, $case, $cased_name, "is_property");
	}
}
