<?php
try{
mb_regex_encoding("SJIS");
mb_internal_encoding("SJIS");

include(_f("freeimage.inc.php"));

//Winbinder CuCN[h
include(_f("libWBWrapper/winbinder.php"));
include(_f("libWBWrapper/WBWrapper.php"));

include(_f("trimcover.form.php"));


class Form1 extends Form1_Base
{
    public $isize, $isrc, $pages, $h, $l, $wt, $wb, $ipre = null;
    
    final static public function Show($parent = null)
    {
        parent::ShowClass($parent, __CLASS__);
    }
    function onLoad()
    {
        global $argv;

        // Cxg̊蓖
        $this->scrL->addEventHandler(0, array($this, "onChangedCtrls"));
        $this->sldWT->addEventHandler(0, array($this, "onChangedCtrls"));
        $this->sldWB->addEventHandler(0, array($this, "onChangedCtrls"));
        $this->addEventHandler(WM_KEYDOWN, array($this, "onKeyDown"));

        $this->isize = $isize = GetImageSize($argv[1]);
        var_dump($isize);
        if (! $isize) throw new Exception(sprintf('ǂݍݎs [%s]', $argv[1]));

        $this->setText($argv[1]);

        $this->isrc = ImageCreateFromString(file_get_contents($argv[1]));

        $this->pages = count(scandir(mb_dirname($argv[1]))) - 2;

        // Ƃĕ\̕o
        // h210mm => w148mm = 0.7047
        // h182mm => w128mm = 0.7032
        // => 0.7

        $this->h = $isize[1];
        $this->wt = (int) round(((float) $this->h) * 0.7);

        // w\̕y[WvZ
        // h210mm 114p => 10mm => 0.0877mm/p
        // h210mm 128p => 12mm => 0.09375mm/p
        // h210mm 200p => 19mm => 0.095mm/p
        $this->wb = (int) round(0.00045 * ((float) $this->h) * ((float) $this->pages));

        if ($isize[0] < ($this->wt * 2) + $this->wb + (($this->wt / 3) * 2)) {
            // w\
            $isize[0] += $isize[0] - ($this->wb + (int) round((float) $this->h * 0.01));
        } else {
            // Xɂēǂݎ薖؂Ă̂ŁA␳
            $isize[0] += (int) round(((float) $isize[0]) * 0.0045);
            //$isize[0] -= (int) round(((float) $isize[0]) * 0.0045);
        }

        $this->l = (($isize[0] - $this->wb) / 2) - $this->wt;
        printf("\: %dpx, \: %dpx, w\: %dpx\n", $this->h, $this->wt, $this->wb);


        $this->setCtrls();
        $this->previewImage();
    }

    function setCtrls()
    {
        $this->scrL->SetScrollBarRange(0, $this->isize[0] - ($this->wt + $this->wb));
        $this->scrL->SetScrollBarPos($this->l, true);
        $this->sldWT->SetSliderRange(1, $this->isize[0] - 1, true);
        $this->sldWT->SetPos($this->wt, true);
        $this->sldWB->SetSliderRange(1, $this->isize[0] - $this->wt, true);
        $this->sldWB->SetPos($this->wb, true);
    }

    function onChangedCtrls()
    {
        // Dx̒Ⴂ珈

        $this->l = $this->scrL->GetScrollBarPos();

        if ($this->wb > $this->sldWB->GetPos()) {
            var_dump($this->isize[0], $this->l + $this->wt + $this->wb);
            if ($this->l + $this->wt + $this->wb == $this->isize[0]) {
                $new = $this->sldWB->GetPos();
                $this->l += $this->wb - $new;
                $this->wb = $new;
            } else {
                $this->wb = $this->sldWB->GetPos();
            }
        } else {
            $this->wb = $this->sldWB->GetPos();
        }

        if ($this->wt > $this->sldWT->GetPos()) {
            if ($this->l + $this->wt + $this->wb == $this->isize[0]) {
                $new = $this->sldWT->GetPos();
                $this->l += $this->wt - $new;
                $this->wt = $new;
            } else {
                $this->wt = $this->sldWT->GetPos();
            }
        } else {
            $this->wt = $this->sldWT->GetPos();
        }

        if ($this->wt < 1) {
            $this->wt = 1;
        }
        if ($this->wb < 1) {
            $this->wb = 1;
        }
        if ($this->l < 0) {
            $this->l = 0;
        }

        // wtD
        if ($this->wt > $this->isize[0] - 1) {
            $this->wt = $this->isize[0] - 1;
        }
        if ($this->wb > $this->isize[0] - $this->wt) {
            $this->wb = $this->isize[0] - $this->wt;
        }
        if ($this->l > $this->isize[0] - ($this->wt + $this->wb)) {
            $this->l = $this->isize[0] - ($this->wt + $this->wb);
        }

        $this->setCtrls();
        $this->previewImage();
    }

    function previewImage()
    {

        if (is_null($this->ipre)) {
            $ph = $this->frmImage1->Height;
            $pw = (int) (((float) $ph / (float) $this->isize[1]) * (float) $this->isize[0]);
            printf("preview image size: %d x %d\n", $pw, $ph);
            $this->ipre = ImageCreateTrueColor($pw, $ph);
            ImageCopyResampled(
                $this->ipre, $this->isrc,
                0, 0,
                0, 0,
                $pw, $ph,
                $this->isize[0], $this->isize[1]
            );
        }

        printf("l=%d, wt=%d, wb=%d\n", $this->l, $this->wt, $this->wb);

        $r = (float) ImageSY($this->ipre) / (float) ImageSY($this->isrc);

        $imt = ImageCreateTrueColor($this->wt * $r, $this->h * $r);
        ImageCopy(
            $imt, $this->ipre,
            0, 0,
            $this->l * $r, 0,
            $this->wt * $r, $this->h * $r
        );
        ImageJPEG($imt, mb_dirname(__FILE__).'/trimcover.tmp.0.jpg', 80);
        ImageDestroy($imt);

        $this->setImage($this->frmImage1, mb_dirname(__FILE__).'/trimcover.tmp.0.jpg');

        $imb = ImageCreateTrueColor($this->wb * $r, $this->h * $r);
        ImageCopy(
            $imb, $this->ipre,
            0, 0,
            ($this->l + $this->wt) * $r, 0,
            $this->wb * $r, $this->h * $r
        );
        ImageJPEG($imb, mb_dirname(__FILE__).'/trimcover.tmp.1.jpg', 80);
        ImageDestroy($imb);

        $this->setImage($this->frmImage2, mb_dirname(__FILE__).'/trimcover.tmp.1.jpg');
    }

    function setImage(WbCtrl $ctrl, $filename)
    {
        $type = FreeImage_GetFileType($filename);
        $img = FreeImage_Load($type, $filename);
        
        $rw = $ctrl->Width  / FreeImage_GetWidth($img);
        $rh = $ctrl->Height / FreeImage_GetHeight($img);
        $r = min($rw, $rh);
        
        $img2 = FreeImage_Rescale(
            $img,
            FreeImage_GetWidth($img) * $r,
            FreeImage_GetHeight($img) * $r,
            FILTER_LANCZOS3);
        FreeImage_Unload($img);
        
        $wimg = wb_create_image(
            FreeImage_GetWidth($img2),
            FreeImage_GetHeight($img2),
            FreeImage_GetInfoHeader($img2),
            FreeImage_GetBits($img2));
        FreeImage_Unload($img2);
        wb_set_image($ctrl->ObjId, $wimg);
        
        wb_destroy_image($wimg);
    }

    function onKeyDown($ctrl, $id, $wParam, $lParam)
    {
        global $argv;

        switch ($wParam) {
        case VK_RETURN:
            printf("l=%d, wt=%d, wb=%d\n", $this->l, $this->wt, $this->wb);

            $imt = ImageCreateTrueColor($this->wt, $this->h);
            ImageCopy(
                $imt, $this->isrc,
                0, 0,
                $this->l, 0,
                $this->wt, $this->h
            );
            ImageJPEG($imt, mb_dirname($argv[1]).'/000a.jpg', 80);
            ImageDestroy($imt);

            $imb = ImageCreateTrueColor($this->wb, $this->h);
            ImageCopy(
                $imb, $this->isrc,
                0, 0,
                $this->l + $this->wt, 0,
                $this->wb, $this->h
            );
            ImageJPEG($imb, mb_dirname($argv[1]).'/000b.jpg', 80);
            ImageDestroy($imb);

            $this->destroy();
            break;

        case VK_ESCAPE:
            $this->destroy();
            break;

        case VK_LEFT:
        case VK_RIGHT:
            $delta = 10;
            if (Win32API_GetKeyState(VK_SHIFT) & 0x8000) {
                $delta = 1;
            }
            if ($wParam == VK_LEFT) {
                $delta = 0 - $delta;
            }
            $this->scrL->SetScrollBarPos($this->scrL->GetScrollBarPos() + $delta);
            $this->onChangedCtrls();
            break;

        case 0xDB:
        case 0xDD:
            $delta = 10;
            if (Win32API_GetKeyState(VK_SHIFT) & 0x8000) {
                $delta = 1;
            }
            if ($wParam == 0xDB) {
                $delta = 0 - $delta;
            }
            $this->sldWB->SetPos($this->sldWB->GetPos() + $delta);
            $this->onChangedCtrls();
            break;

        default:
            printf("keyDown: 0x%02X\n", $wParam);
            break;
        }
    }
}


//CEBhE\
Form1::Show();

//C[vJn
//wb_main_loop();
WBWrapper::MainLoop();


// OLb`
} catch(Exception $e) {
    function relatedpath($path) {
        if(substr($path, 0, strlen(dirname(__FILE__))) == dirname(__FILE__))
            return substr($path, strlen(dirname(__FILE__))+1);
        else
            return $path;
    }
    echo "Fatal error: Uncaught exception '".get_class($e)."'\n";
    echo "  message : ".$e->getMessage()."\n";
    echo "  location: ".relatedpath($e->getFile())." [".$e->getLine()."]\n";
    echo "  code    : ".$e->getCode()."\n";
    echo "\n";
    echo "  stack trace:\n";
    
    $file = ''; $line = 0;
    foreach(array_splice($e->getTrace(), 0, -2) as $i => $s) {
        if(isset($s['file'])) $file = $s['file'];
        if(isset($s['line'])) $line = $s['line'];
        
        echo "   ".sprintf("% 2d", $i).":\n";
        echo "      location: ".relatedpath($file)." [".$line."]\n";
        if(isset($s['class'])) {
            echo "      function: ".$s['class'].$s['type'].$s['function']."\n";
        } else
            echo "      function: ".$s['function']."\n";
        $args = array();
        foreach($s['args'] as $p) {
            switch(strtolower(gettype($p))) {
            case 'integer':
                $args[] = $p; break;
                
            case 'string':
                $args[] = "\"{$p}\""; break;
                
            case 'object':
                $args[] = "object(".get_class($p).")"; break;
                
            case 'null':
                $args[] = "NULL"; break;
                
            case 'array':
                $args[] = "Array"; break;
                
            default:
                trigger_error('UnknownType['.gettype($p).']', E_USER_ERROR);
            }
        }
        echo "      args    : ".join(', ', $args)."\n";
    }
    
    //var_dump($e->getTrace());
    //trigger_error('test', E_ERROR);
    exit(1);
}





function mb_basename($fname)
{
    $ret = mb_split("[\\\\/]", $fname);
    return array_pop($ret);
}
function mb_dirname($fname)
{
    $base = mb_basename($fname);
    return substr($fname, 0, 0-(strlen($base)+1));
}

class log_filter extends php_user_filter
{
    function filter($in, $out, &$consumed, $closing)
    {
        while ($bucket = stream_bucket_make_writeable($in))
        {
            $fp = fopen('.log.txt', 'ab');
            fwrite($fp, $bucket->data);
            fclose($fp);
            $consumed += $bucket->datalen;
            stream_bucket_append($out, $bucket);
        }
        return PSFS_PASS_ON;
    }
}

function logprint($txt)
{
    global $output;
    fwrite($output, $txt);
}
?>
