<?
/*------------------------------------------

[Depends]

[Document]
lib_wb.phpƕps

------------------------------------------*/

//PHP5ȏŎs
if(version_compare(phpversion(), "5.0.0", "<")) return 0;

function Win32API_PeekMessage(&$MSG, $hwnd = NULL, $filterMin = 0, $filterMax = 0, $RemoveMsg = false)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("PeekMessage", wb_load_library("user32"));
	
	$sMSG = $MSG;
	//$RemoveMsg = $RemoveMsg ? 1 : 0;
	$ret = wb_call_function($funcaddr, array($sMSG, $hwnd, $filterMin, $filterMax, (int)$RemoveMsg));
	$MSG = $sMSG;
	return $ret;
}
function Win32API_GetMessage(&$MSG, $hwnd = NULL, $filterMin = 0, $filterMax = 0)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GetMessage", wb_load_library("user32"));
	
	$sMSG = $MSG;
	$ret = wb_call_function($funcaddr, array($sMSG, $hwnd, $filterMin, $filterMax));
	$MSG = $sMSG;
	return $ret;
}
function Win32API_WaitMessage()
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("WaitMessage", wb_load_library("user32"));
	
	$ret = wb_call_function($funcaddr, array());
	return $ret;
}
function Win32API_TranslateMessage(&$MSG)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("TranslateMessage", wb_load_library("user32"));
	
	$sMSG = $MSG;
	$ret = wb_call_function($funcaddr, array($sMSG));
	$MSG = $sMSG;
	return $ret;
}
function Win32API_DispatchMessage(&$MSG)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("DispatchMessage", wb_load_library("user32"));
	
	$sMSG = $MSG;
	$ret = wb_call_function($funcaddr, array($sMSG));
	$MSG = $sMSG;
	return $ret;
}
function Win32API_SendMessage($hWnd, $msg, $wParam = NULL, &$lParam = NULL)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("SendMessage", wb_load_library("user32"));
	
	settype($hWnd, "integer");
	settype($msg, "integer");
	settype($wParam, "integer");
	
	switch(gettype($lParam))
	{
	case "string":
		$str = $lParam;
		$ret = wb_call_function($funcaddr, array($hWnd, $msg, $wParam, wb_get_address($str)));
		$lParam = $str;
		return $ret;
	default:
		$slParam = $lParam;
		$ret = wb_call_function($funcaddr, array($hWnd, $msg, $wParam, $slParam));
		$lParam = $slParam;
		return $ret;
	}
}
function Win32API_PostMessage($hWnd, $msg, $wParam = NULL, &$lParam = NULL)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("PostMessage", wb_load_library("user32"));
	
	settype($hWnd, "integer");
	settype($msg, "integer");
	settype($wParam, "integer");
	
	switch(gettype($lParam))
	{
	case "string":
		$str = $lParam;
		$ret = wb_call_function($funcaddr, array($hWnd, $msg, $wParam, wb_get_address($str)));
		$lParam = $str;
		return $ret;
	default:
		$slParam = $lParam;
		$ret = wb_call_function($funcaddr, array($hWnd, $msg, $wParam, $slParam));
		$lParam = $slParam;
		return $ret;
	}
}
function Win32API_RegisterWindowMessage($msg)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("RegisterWindowMessage", wb_load_library("user32"));
	
	settype($msg, 'string');
	
	$ret = wb_call_function($funcaddr, array(wb_get_address($msg)));
	return $ret;
}
function Win32API_WaitForSingleObject($hHandle, $wait)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("WaitForSingleObject", wb_load_library("kernel32"));
	
	settype($hHandle, "integer");
	settype($wait, "integer");
	
	$ret = wb_call_function($funcaddr, array($hHandle, $wait));
	return $ret;
}
