<?
/*------------------------------------------

[Depends]

[Document]
lib_wb.phpƕps

------------------------------------------*/

//PHP5ȏŎs
if(version_compare(phpversion(), "5.0.0", "<")) return 0;

// Win32API
function Win32API_GetDC($hwnd)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("GetDC", wb_load_library("user32"));
	
	$ret = wb_call_function($funcaddr, array($hwnd));
	return $ret;
}
function Win32API_ReleaseDC($hwnd, $hdc)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("ReleaseDC", wb_load_library("user32"));
	
	$ret = wb_call_function($funcaddr, array($hwnd, $hdc));
	return $ret;
}
function Win32API_CreateCompatibleDC($hdc)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("CreateCompatibleDC", wb_load_library("gdi32"));
	
	$ret = wb_call_function($funcaddr, array($hdc));
	return $ret;
}
function Win32API_DeleteDC($hdc)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("DeleteDC", wb_load_library("gdi32"));
	
	$ret = wb_call_function($funcaddr, array($hdc));
	return $ret;
}
function Win32API_CreateCompatibleBitmap($hdc, $width, $height)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("CreateCompatibleBitmap", wb_load_library("gdi32"));
	
	$ret = wb_call_function($funcaddr, array($hdc, $width, $height));
	return $ret;
}
function Win32API_SelectObject($hdc, $hobj)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("SelectObject", wb_load_library("gdi32"));
	
	$ret = wb_call_function($funcaddr, array($hdc, $hobj));
	return $ret;
}
function Win32API_DeleteObject($hobj)
{
	static $funcaddr = NULL;
	if(is_null($funcaddr))
		$funcaddr = wb_get_function_address("DeleteObject", wb_load_library("gdi32"));
	
	$ret = wb_call_function($funcaddr, array($hobj));
	return $ret;
}


class WbBitmap extends WbWrapper_prop_base_class {
	// veNebho
		protected $_hbmp = null;
		protected $_hdcbmp = null;
		protected $_hobjold = null;
	
	// RXgN^
		protected function __construct() {
		}
	
	// fXgN^
		public function __destruct() {
			// IuWFNg̑I߂
			if($this->_hobjold != 0)
				Win32API_SelectObject($this->_hdcbmp, $this->_hobjold);
			
			// DC
			if($this->_hdcbmp != 0)
				Win32API_DeleteDC($this->_hdcbmp);
			
			// rbg}bv
			if($this->_hbmp != 0)
				Win32API_DeleteObject($this->_hbmp);
		}
	
	// X^eBbN\bh
		static public function Create($width, $height) {
			$hdc = null;
			$hbmp = null;
			$hdcbmp = null;
			$hobjold = null;
			
			$ret = false;
			while(1) {
				
				// XN[DC擾
				$hdc = Win32API_GetDC(0);
				if($hdc == 0) break;
				
				// rbg}bv쐬
				$hbmp = Win32API_CreateCompatibleBitmap($hdc, $width, $height);
				if($hbmp == 0) break;
				
				// DC쐬
				$hdcbmp = Win32API_CreateCompatibleDC($hdc);
				if($hdcbmp == 0) break;
				
				// rbg}bvIuWFNgI
				$hobjold = Win32API_SelectObject($hdcbmp, $hbmp);
				if($hobjold == 0) break;
				
				// IuWFNg쐬
				$ret = new WbBitmap();
				$ret->_hbmp = $hbmp; $hbmp = null;
				$ret->_hdcbmp = $hdcbmp; $hdcbmp = null;
				$ret->_hobjold = $hobjold; $hobjold = null;
				
				// I
				break;
			}
			
			// IuWFNg̑I߂
			if($hobjold != 0)
				Win32API_SelectObject($hdcbmp, $hobjold);
			
			// DC
			if($hdcbmp != 0)
				Win32API_DeleteDC($hdcbmp);
			
			// rbg}bv
			if($hbmp != 0)
				Win32API_DeleteObject($hbmp);
			
			// XN[DC
			if($hdc != 0)
				Win32API_ReleaseDC(0, $hdc);
			
			return $ret;
		}
}

?>