<?
/*------------------------------------------

[Depends]

[Document]
lib_wb.phpƕps

------------------------------------------*/

//PHP5ȏŎs
if(version_compare(phpversion(), "5.0.0", "<")) return 0;

//// {Rg[ ////
class WbCtrl extends WbWnd
{
	protected $_id;
	protected $_tabstop = true;
	
	//RXgN^
	function __construct($ctrl, $parent, $args = array())
	{
		parent::__construct($ctrl, $parent, $args);
		$this->_id = wb_get_id($ctrl);
	}
	
	//Rg[
	static function CreateControlClass($classname, $parent, $cclass)
	{
		$pwnd = null;
		// eEBhEmF
		if(! is_null($parent)) {
			// EBhẼNXႤ
			if(! ($parent instanceof WbWnd))
				throw new WbInvalidArgumentException();
			
			$pwnd = $parent->ObjID;
		}
		
		// Rg[
		$args = func_get_args();
		array_shift($args);
		$args[0] = $pwnd;
		$ctrl = call_user_func_array('wb_create_control', $args);
		
		// NXCX^X𐶐
		if(is_null($classname))
			$obj = WbWrapper::CreateCtrlWrapperClass($ctrl, $pwnd, $cclass, $args);
		else
			$obj = new $classname($wnd, $pwnd, $args);
		WBWrapper::$_Windows[$ctrl] = $obj;
		WBWrapper::$_hWnds[$obj->_hWnd] = $obj;
		
		return $obj;
	}
	
	function Destroy()
	{
		wb_destroy_control($this->ObjID);
	}
	
	//Rg[ID擾
	function GetID()
	{
		return $this->_id;
	}
	protected $_propID = true;
	
	//Enabled
	function GetEnabled()
	{
		//echo get_class($this).": (".join(" <= ", get_debug_backtrace(-1, "function")).")"."\n";
		return wb_get_enabled($this->ObjID);
	}
	function SetEnabled($val)
	{
		//echo get_class($this).": (".join(" <= ", get_debug_backtrace(-1, "function")).")"."\n";
		return wb_set_enabled($this->ObjID, $val);
	}
	protected $_propEnabled = true;
	
	//Value
	function GetValue()
	{
		//echo get_class($this).": (".join(" <= ", get_debug_backtrace(-1, "function")).")"."\n";
		return wb_get_value($this->ObjID);
	}
	function SetValue($val)
	{
		//echo get_class($this).": (".join(" <= ", get_debug_backtrace(-1, "function")).")"."\n";
		return wb_set_value($this->ObjID, $val);
	}
	protected $_propValue = true;
	
	//Visible
	function GetVisible()
	{
		//echo get_class($this).": (".join(" <= ", get_debug_backtrace(-1, "function")).")"."\n";
		return wb_get_visible($this->ObjID);
	}
	function SetVisible($val)
	{
		//echo get_class($this).": (".join(" <= ", get_debug_backtrace(-1, "function")).")"."\n";
		return wb_set_visible($this->ObjID, $val);
	}
	protected $_propVisible = true;
	
	//TabIndex
	function GetTabIndex()
	{
		if(! $this->TopParent instanceof WbWindow) return -1;
		if(! is_array($this->TopParent->TabIndexes)) return -1;
		if(! in_array($this, $this->TopParent->TabIndexes)) return -1;
		return array_search($this->ObjID, $this->TopParent->TabIndexes);
	}
	function SetTabIndex($index)
	{
		if(! $this->TopParent instanceof WbWindow) return -1;
		
		if(! is_array($this->TopParent->tabIndexes))
			$arr = array();
		else
			$arr = $this->TopParent->tabIndexes;
		
		if(in_array($this->ObjID, $arr))
		{
			$oindex = array_search($this->ObjID, $arr);
			$arr = array_splice($arr, $oindex, 1);
		}
		if($index >= count($arr))
			$arr[] = $this->ObjID;
		else
			$arr = array_splice($arr, $index, 0, $this->ObjID);
		
		$this->TopParent->tabIndexes = $arr;
	}
	protected $_propTabIndex = true;
	//TabStop
	function GetTabStop()
	{
		return $this->_tabstop && ($this->TabIndex != -1);
	}
	function SetTabStop($val)
	{
		if(! $this->TopParent instanceof WbWindow) return false;
		if(! is_array($this->TopParent->TabIndexes)) return false;
		
		$arr = $this->TopParent->TabIndexes;
		
		if($this->TabIndex == -1)
		{
			$arr[] = $this->ObjID;
		}
		
		$this->TopParent->TabIndexes = $arr;
	}
	protected $_propTabStop = true;
	
	//SetFocus
	function SetFocus()
	{
		return wb_set_focus($this->_wnd);
	}
	
	//ftHg̃Cxgnh
	function _defaultEventHandler($wnd, $msg, $wparam, $lparam)
	{
		switch ($msg)
		{
		}
		
		return true;
	}
}


//CN[h
if(! function_exists("_f"))
{
	function _f($fname){ return $fname; }
}
include(_f("WbWrapper_Control_EditBox.php"));
include(_f("WbWrapper_Control_HTMLControl.php"));
include(_f("WbWrapper_Control_CheckBox.php"));
include(_f("WbWrapper_Control_RadioButton.php"));
include(_f("WbWrapper_Control_ListBox.php"));
include(_f("WbWrapper_Control_ComboBox.php"));
include(_f("WbWrapper_Control_ListView.php"));
include(_f("WbWrapper_Control_ScrollBar.php"));
include(_f("WbWrapper_Control_Gauge.php"));
include(_f("WbWrapper_Control_Slider.php"));

