<?
/*------------------------------------------

[Depends]

[Document]
lib_wb.phpƕps

------------------------------------------*/

//PHP5ȏŎs
if(version_compare(phpversion(), "5.0.0", "<")) return 0;

//// Xg{bNX ////
define("LB_ADDFILE", 0x196);
define("LB_ADDSTRING", 0x180);
define("LB_CTLCODE", 0x0);
define("LB_DELETESTRING", 0x182);
define("LB_DIR", 0x18D);
define("LB_ERR", -1);
define("LB_ERRSPACE", -2);
define("LB_FINDSTRING", 0x18F);
//define("LB_FINDSTRINGEXACT", 0x1A2);
define("LB_GETANCHORINDEX", 0x19D);
define("LB_GETCARETINDEX", 0x19F);
define("LB_GETCOUNT", 0x18B);
define("LB_GETCURSEL", 0x188);
define("LB_GETHORIZONTALEXTENT", 0x193);
define("LB_GETITEMDATA", 0x199);
define("LB_GETITEMHEIGHT", 0x1A1);
define("LB_GETITEMRECT", 0x198);
define("LB_GETLOCALE", 0x1A6);
define("LB_GETSEL", 0x187);
define("LB_GETSELCOUNT", 0x190);
define("LB_GETSELITEMS", 0x191);
define("LB_GETTEXT", 0x189);
define("LB_GETTEXTLEN", 0x18A);
define("LB_GETTOPINDEX", 0x18E);
define("LB_INITSTORAGE", 0x1A8);
define("LB_INSERTSTRING", 0x181);
define("LB_ITEMFROMPOINT", 0x1A9);
define("LB_MSGMAX", 0x1A8);
define("LB_OKAY", 0x0);
define("LB_RESETCONTENT", 0x184);
define("LB_SELECTSTRING", 0x18C);
define("LB_SELITEMRANGE", 0x19B);
define("LB_SELITEMRANGEEX", 0x183);
define("LB_SETANCHORINDEX", 0x19C);
define("LB_SETCARETINDEX", 0x19E);
define("LB_SETCOLUMNWIDTH", 0x195);
define("LB_SETCOUNT", 0x1A7);
//define("LB_SETCURSEL", 0x186);
define("LB_SETHORIZONTALEXTENT", 0x194);
define("LB_SETITEMDATA", 0x19A);
define("LB_SETITEMHEIGHT", 0x1A0);
define("LB_SETLOCALE", 0x1A5);
define("LB_SETSEL", 0x185);
define("LB_SETTABSTOPS", 0x192);
define("LB_SETTOPINDEX", 0x197);
define("LBN_DBLCLK", 0x2);
define("LBN_ERRSPACE", -2);
define("LBN_KILLFOCUS", 0x5);
define("LBN_SELCANCEL", 0x3);
define("LBN_SELCHANGE", 0x1);
define("LBN_SETFOCUS", 0x4);
define("LBS_DISABLENOSCROLL", 0x1000);
define("LBS_EXTENDEDSEL", 0x800);
define("LBS_HASSTRINGS", 0x40);
define("LBS_MULTICOLUMN", 0x200);
define("LBS_MULTIPLESEL", 0x8);
define("LBS_NODATA", 0x2000);
define("LBS_NOINTEGRALHEIGHT", 0x100);
define("LBS_NOREDRAW", 0x4);
define("LBS_NOSEL", 0x4000);
define("LBS_NOTIFY", 0x1);
define("LBS_OWNERDRAWFIXED", 0x10);
define("LBS_OWNERDRAWVARIABLE", 0x20);
//define("LBS_SORT", 0x2);
define("LBS_STANDARD", (LBS_NOTIFY | LBS_SORT | 0x00200000 | 0x00800000));
define("LBS_USETABSTOPS", 0x80);
define("LBS_WANTKEYBOARDINPUT", 0x400);
class WbCtrlListBox extends WbCtrl
{
	protected $_values;
	
	//RXgN^
	function __construct($ctrl, $parent, $args = array())
	{
		parent::__construct($ctrl, $parent, $args);
		
		$this->_values = new ArrayList();
	}
	
	//ACȇ}
	function InsertItem($index, $str, $value = NULL)
	{
		if(FAILED($index = $this->SendMessage(LB_INSERTSTRING, $index, $str)))
			return $index;
		
		$this->_values->InsertAt($index, $value);
		
		return $index;
	}
	
	//ACe̒ǉ
	function AddItem($str, $value = NULL)
	{
		return $this->InsertItem($this->Count, $str, $value);
	}
	
	//ACe̍폜
	function DeleteItem($index)
	{
		if(FAILED($ret = $this->SendMessage(LB_DELETESTRING, $index)))
			return $ret;
		
		$this->_values->RemoveAt($index);
		return $ret;
	}
	function RemoveItem($index)
	{
		return $this->DeleteItem($index);
	}
	//ACȇS폜
	function RemoveAll()
	{
		while($this->Count)
		{
			$this->RemoveItem(0);
		}
	}
	
	//ACe̎擾
	function GetCount()
	{
		return wb_get_item_count($this->ObjID);
	}
	protected $_propCount = true;
	
	//ACe̎̕擾
	function GetItemText($index)
	{
		if($index >= $this->Count) return LB_ERR;
		
		if(FAILED($len = $this->SendMessage(LB_GETTEXTLEN, $index)))
			return $len;
		$str = str_repeat(chr(0), $len);
		if(FAILED($len = $this->SendMessage(LB_GETTEXT, $index, $str)))
			return $len;
		return $str;
	}
	//ACe̐̕ݒ
	function SetItemText($index, $str)
	{
		if($index >= $this->Count) return LB_ERR;
		
		$cur = $this->GetCurrent();
		
		if(FAILED($value = $this->GetValue($index)))
			$value = NULL;
		
		if(FAILED($ret = $this->DeleteItem($index))) return $ret;
		
		if(FAILED($ret = $this->InsertItem($index, $str, $value)))
			return $ret;
		$this->SetCurrent($cur);
		return $ret;
	}
	
	//ACeɊ֘Atꂽl
	function GetItemValue($index)
	{
		if($index >= $this->Count) return LB_ERR;
		
		return $this->_values[$index];
	}
	function SetItemValue($index, $value)
	{
		if($index >= $this->Count) return LB_ERR;
		
		$this->_values[$index] = $value;
		return 0;
	}
	
	
	//w肵CfbNX̃ACe擾
	function Item($index)
	{
		if($index >= $this->Count) return LB_ERR;
		
		return new WbCtrlListBoxItem($this, $index);
	}
	//ACe̔z擾
	function GetItems()
	{
		$arr = array();
		for($i = 0; $i < $this->GetCount(); $i++)
		{
			$arr[] = new WbCtrlListBoxItem($this, $i);
		}
		return $arr;
	}
	protected $_propItems = true;
	
	//Jg
	function GetCurrent()
	{
		return $this->SendMessage(LB_GETCURSEL);
	}
	function SetCurrent($index)
	{
		return $this->SendMessage(LB_SETCURSEL, $index);
	}
	
	//I
	function GetSelected($index)
	{
		return $this->SendMessage(LB_GETSEL, $index);
	}
	function SetSelected($index, $selected = true)
	{
		return $this->SendMessage(LB_SETSEL, $selected, $index);
	}
}
class WbCtrlListBoxItem extends WbWrapper_prop_base_class
{
	protected $_ctrl = NULL;
	protected $_index = -1;
	
	function __construct($ctrl, $index)
	{
		$this->_ctrl = $ctrl;
		$this->_index = $index;
	}
	
	function GetText()
	{
		return $this->_ctrl->GetText($this->_index);
	}
	function SetText($str)
	{
		return $this->_ctrl->SetText($this->_index, $str);
	}
	protected $_propText = true;
	
	function GetValue()
	{
		return $this->_ctrl->GetValue($this->_index);
	}
	function SetValue($value)
	{
		return $this->_ctrl->SetValue($this->_index, $value);
	}
	protected $_propValue = true;
	
	function GetSelected()
	{
		return $this->_ctrl->GetSelected($this->_index);
	}
	function SetSelected($value)
	{
		return $this->_ctrl->SetSelected($this->_index, $value);
	}
	protected $_propSelected = true;
}

?>