<?php
/*
akeysort  <MAYA>

(c)MAYA
http://fei-yen.jp/

-----------------------
Qz̓̃tB[hL[Ƃă\[g
-----------------------

[History]
2006/08/30	v1.15	tɂł悤ɂ
2006/08/29	v1.14	Azz̃L[Ń\[gł悤ɂ
					啶ʂȂIvVǉ
2006/05/31	v1.13	L[ێtOǉ
					asortɃtOnĂȂ̂C
2006/04/25	v1.12	̓f[^IɐlɕϊtOǉ
2006/04/25	v1.11	\[gɑΉ
2006/04/25	v1.10	R\[gɑΉ
2006/03/31	v1.00	VK쐬

*/

if(! function_exists("akeysort"))
{
	define(SORT_NATURAL, 128);
	define(SORT_FORCE_NUMBER, 256);
	define(SORT_PRESERVE_KEYS, 512);
	define(SORT_CASE, 1024);	//啶ʂȂ
	define(SORT_REVERSE, 2048);	//啶ʂȂ
	function akeysort(&$ar, $arkey = null, $flag = SORT_REGULAR)
	{
		$keys = array();
		if($arkey == null)
		{
			if($flag & SORT_CASE)
				foreach($ar as $key => $line)
				{
					$keys[$key] = strtolower($key);
				}
			else
				foreach($ar as $key => $line)
				{
					$keys[$key] = $key;
				}
		}
		else
		{
			foreach($ar as $key => $line)
			{
				$keys[$key] = $line[$arkey];
			}
		}
		
		if($flag & SORT_FORCE_NUMBER)
		{
			foreach($keys as $key => $val)
			{
				$keys[$key] = preg_replace("/[^\d]/", "", $val);
			}
		}
		//print_r($keys);
		switch($flag)
		{
		case SORT_NATURAL:
			natsort($keys);
			break;
			
		default:
			asort($keys, (int)($flag & (0xFFFF ^ (SORT_FORCENUMBER | SORT_PRESERVE_KEYS | SORT_CASE | SORT_REVERSE))));
			break;
		}
		
		if($flag & SORT_REVERSE)
		{
			$keys = array_reverse($keys, true);
		}
		
		$new = array();
		if($flag & SORT_PRESERVE_KEYS)
		{
			foreach($keys as $key => $val)
			{
				$new[$key] = $ar[$key];
			}
		}
		else
		{
			foreach($keys as $key => $val)
			{
				$new[] = $ar[$key];
			}
		}
		
		//echo "<pre>"; print_r($new); echo "</pre>";
		$ar = $new;
		return;
	}
}

?>